<template>
  <rui-form model="element"
            :errors="errors"
            :loading="loading"
            @submit.prevent="save"
            @cancel="cancel">
    <rui-date-time-picker v-model="inputs.implantation_planned_for"
                          :label="$t('js.elements.action_buttons.plantation_date')"
                          :time="false"
                          :input-id="`${formId}-implanted-at`"
                          input-name="implanted_at" />
    <h3>{{ $t('activerecord.attributes.element.implantation_mode') }}</h3>
    <div class="rui-field">
      <label v-for="mode in modes" :key="mode">
        <input v-model="inputs.implantation_mode" type="radio" name="implantation_mode" :value="mode">
        {{ $t(`activerecord.attributes.element/implantation_mode.${mode}`) }}
      </label>
    </div>
  </rui-form>
</template>

<script>
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import Element from '../../../../classes/models/Element'
import { beginningOfDay } from '@experiments-labs/rise_ui/src/lib/Dates'
import { ELEMENT_IMPLANTATION_MODES } from '../../../../../helpers/constants'

export default {
  name: 'GpaElementImplantationForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiDateTimePicker, RuiForm },
  props: {
    element: { required: true, type: Element },
  },
  data () {
    const today = beginningOfDay(new Date())

    return {
      errors: null,
      loading: false,
      inputs: {
        implantation_planned_for: this.$props.element.implantationPlannedFor || today,
        implantation_mode: null,
      },
      modes: ELEMENT_IMPLANTATION_MODES,
      formId: randomString(),
    }
  },
  methods: {
    save () {
      this.errors = null
      this.loading = true
      const payload = {
        id: this.$props.element.id,
        date: this.inputs.implantation_planned_for,
        implantationMode: this.inputs.implantation_mode,
      }
      return this.$store.dispatch('implantElement', payload)
        .then(() => { this.$emit('saved') })
        .catch((error) => {
          this.errors = error
        })
        .then(() => {
          this.loading = false
        })
    },
    cancel () { this.$emit('cancel') },
  },
}
</script>
